// Send Go Signal
void command_go()
{
   output_high(SUPERGO);
   delay_us(1);
   output_low(SUPERGO);
}

void write_command(int8 remote_addr, int8 command, int32 data_packet)
{
   i2c_start();                        // Assert i2c Bus
   i2c_write(remote_addr);             // Address
   i2c_write(command);                 // Command
   i2c_write((int8) data_packet);      // Data (b0)
   i2c_write(data_packet>>8);          // Data (b1)
   i2c_write(data_packet>>16);         // Data (b2)
   i2c_write(data_packet>>24);         // Data (b3)
   i2c_stop();                         // Release i2c Bus
   delay_us(10);                       // Delay?
}

int32 mc_request(int remote_addr, int datatype)
{
   int ii;
   int input[4] = {0,0,0,0};
   
   for(ii=0;ii<4;ii++)              //change this back
   {
      i2c_start();                       //begin communication
      i2c_write(remote_addr);                 //send slave address
      i2c_write(datatype-ii);
      i2c_start();                       //send repeated start command to begin read cycle
      i2c_write (remote_addr+1);               //add 1 to the address to send a write bit
      input[ii] = i2c_read(0);            //read requested information from the slave
      i2c_stop ();                        //terminate communication
   }
   return make32(input[3], input[2], input[1], input[0]);
}

int32 mc_get_pos(int remote_addr)
{
   int32 position;   
   position = mc_request(remote_addr,255);
   return ((int32)position);
}

void mc_transmit(int device, int* output[5])
{
   int ii;
   
   i2c_start();                  //begin transmission
   i2c_write(device);            //select address of device to communicate with
   for(ii=0;ii<5;   ii++)
   {
      i2c_write(output[ii]);
   }
   i2c_stop();
   delay_us(10);
}

void mc_set_acc_post(int device, signed int32 accel)
{
   int* output[5] = {0,0,0,0,0};
   int ii;
   
   output[0] = 7;
   for(ii=0;ii<4;ii++)
   {
      output[ii+1] = (int8)(accel>>(8*(ii)));
   }
   mc_transmit(device,output);
}


void mc_set_rel_pos(int device, signed int32 position)
{
   int* output[5] = {0,0,0,0,0};
   int ii;
   
   output[0] = 2;
   for(ii=0;ii<4;ii++)
   {
      output[ii+1] = (int8)(position>>(8*(ii)));
   }
   mc_transmit(device,output);
}

void mc_set_vel(int device, signed int32 velocity)
{
   int* output[5] = {0,0,0,0,0};
   int ii;
   //output_d(velocity);
   output[0] = 3;
   for(ii=0;ii<4;ii++)
   {
      output[ii+1] = (int8)(velocity>>(8*(ii)));
   }
   mc_transmit(device,output);
}

void mc_abort_reset(int device)
{
   int* output[5] = {4,0,0,0,0};
   mc_transmit(device,output);
}

void mc_abort(int device)
{
   int* output[5] = {5,0,0,0,0};
   mc_transmit(device,output);
}

void mc_crazy_abort(int device)
{
   int* output[5] = {6,0,0,0,0};
   mc_transmit(device,output);
}

void mc_resetpos(int device)
{
   int* output[5] = {10,0,0,0,0};
   mc_transmit(device,output);
}




signed int32 mc_request(int device, int datatype)
{
   int ii;
   int input[4] = {0,0,0,0};
   
   for(ii=0;ii<4;ii++)              //change this back
   {
      i2c_start ();                       //begin communication
      i2c_write (device);                 //send slave address
      i2c_write (datatype-ii);
      i2c_start ();                       //send repeated start command to begin read cycle
      i2c_write (device+1);               //add 1 to the address to send a write bit
      input[ii] = i2c_read(0);            //read requested information from the slave
      i2c_stop ();                        //terminate communication
   }
   return ((int32)input[0]|((int32)input[1]<<8)|((int32)input[2]<<16)|((int32)input[3]<<24));
   //return make32(input[3],input[2],input[1],input[0]);
}

signed int32 mc_get_pos(int device)
{
   int32 position;   
   position = mc_request(device,255);
   return ((signed int32)position);
}

int mc_is_done(int device)
{
   int8 done;
      i2c_start ();                       //begin communication
      i2c_write (device);                 //send slave address
      i2c_write (250);
      i2c_start ();                       //send repeated start command to begin read cycle
      i2c_write (device+1);               //add 1 to the address to send a write bit
      done = i2c_read(0);            //read requested information from the slave
      i2c_stop ();                        //terminate communication
   
   return done;
}

signed int32 mc_get_vel(int device)
{
   int32 velocity;   
   velocity = mc_request(device,251);
   return ((signed int32)velocity);
}

signed int32 mc_get_targetpos(int device)
{
   int32 targetposition;   
   targetposition = mc_request(device,247);
   return ((signed int32)targetposition);
}

signed int32 mc_get_targetvel(int device)
{
   int32 targetvelocity;   
   targetvelocity = mc_request(device,243);
   return ((signed int32)targetvelocity);
}
