// MAIN PIC
#include <18f4520.h>
#include "MainDefines.c"

#DEVICE ADC=8
#fuses HS, NOLVP, NOWDT, NOPROTECT       
#use delay(clock=40000000)
#use I2C(MASTER, SLOW=50000, SCL=MSCK, SDA=MSDA, FORCE_HW)

//Prototype All Functions

//I2c Commands
void command_go();
int32 mc_get_pos(int);
void mc_set_acc_post(int, signed int32);
void mc_set_rel_pos(int, signed int32);

//Main Commands
void rotate(signed int32);
void translate(signed int32);
void waitforgo();
int8 motion_completed();
void wait_for_drive_motors();


//Initialize Main
void initializemain();
void setup();


//Includes
#include "math.h"
#include "I2CCommands.c"
#include "MainCommands.c"
#include "InitializeMain.c"

void setup()
{
   // Make sure Go Pin is low
   output_low(SUPERGO);
   
   // Enable Global Interrupts
   enable_interrupts(GLOBAL);

}

void main()
{
   setup();
   initializemain();
   
   //Sample Code
   while(TRUE)
   {
      // Wait for start button press
      waitforgo();
      
      //Move Forward 1000 mm
      translate(1000);
      
      //Rotate 90 Degrees
      rotate(900); //note that rotate takes input of deci-degrees
      
   }
}
