//Pin Defines
#DEFINE  MSDA        PIN_C4   //I2C Data Line
#DEFINE  MSCK        PIN_C3   //I2C Clock Line
#DEFINE  SUPERGO     PIN_E1   //Line to issue the Go Pulse to start all slaves
#DEFINE  GO_BUTTON   PIN_E2   //Button to start tracking, pull low to start

//Slave Address Defines
#DEFINE  MCLEFT_ADR   0x80    //Left motor contorller I2C address
#DEFINE  MCRIGHT_ADR  0x82    //Right motor contorller I2C address
#DEFINE  PI          3.1415926535


//Byte and Bit defines for I2C
#byte PIC_SSPBUFF=0xFC9
#byte PIC_SSPADD=0xFC8
#byte PIC_SSPSTAT=0xFC7
#byte PIC_SSPCON1=0xFC6
#byte PIC_SSPCON2=0xFC5
#bit  BF = PIC_SSPSTAT.0            // B1 = data transmit in progress, 0 = data transmit complete
#bit  SSPOV = PIC_SSPCON1.6         // I2C Buffer Overflow
#bit  SSPEN = PIC_SSPCON1.5         // SSP Enable Bit


// Time counter
int16 bigtime = 0;

//Polling Var
int   motors_rdy = 1;

